// GraphicView.cpp : CGraphicView ʵ
//

#include "stdafx.h"
#include "Graphic.h"

#include "GraphicDoc.h"
#include "GraphicView.h"
#include "MainFrm.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

 
// CGraphicView

IMPLEMENT_DYNCREATE(CGraphicView, CView)

BEGIN_MESSAGE_MAP(CGraphicView, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_DOT, &CGraphicView::OnDot)
	ON_COMMAND(ID_LINE, &CGraphicView::OnLine)
	ON_COMMAND(ID_Ellipse, &CGraphicView::OnEllipse)
	ON_COMMAND(ID_Rectangle, &CGraphicView::OnRectangle)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(IDM_SETTING, &CGraphicView::OnSetting)
	ON_COMMAND(IDM_COLOR, &CGraphicView::OnColor)
	ON_COMMAND(IDM_FONT, &CGraphicView::OnFont)
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

// CGraphicView /

CGraphicView::CGraphicView()
: m_iLineHeight(1),m_nLineType(0)
, m_strFontName(_T(""))
{
	// TODO: ڴ˴ӹ
	m_Color = RGB(255, 0, 0);
}

CGraphicView::~CGraphicView()
{
}

BOOL CGraphicView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CView::PreCreateWindow(cs);
}

// CGraphicView 

void CGraphicView::OnDraw(CDC* pDC)
{
	CGraphicDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	CFont *pOldFont = pDC->SelectObject(&m_Font);
	pDC->TextOut(0, 0, m_strFontName);
	pDC->SelectObject((pOldFont));
	// TODO: ڴ˴Ϊӻƴ
}


// CGraphicView ӡ

BOOL CGraphicView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CGraphicView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CGraphicView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}


// CGraphicView 

#ifdef _DEBUG
void CGraphicView::AssertValid() const
{
	CView::AssertValid();
}

void CGraphicView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGraphicDoc* CGraphicView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGraphicDoc)));
	return (CGraphicDoc*)m_pDocument;
}
#endif //_DEBUG

void CGraphicView::SetSelectStatus(CString str) //½ʾѡߵ״̬
{
	CClientDC dc(this);
	CSize size = dc.GetTextExtent(str);
	CStatusBar* pStatusBar = (CStatusBar*)AfxGetMainWnd()->GetDescendantWindow(AFX_IDW_STATUS_BAR);
	int iIndex =pStatusBar->CommandToIndex(IDS_TYPE_SELECT);
	pStatusBar->SetPaneText(iIndex, str);
	pStatusBar->SetPaneInfo(iIndex, IDS_TYPE_SELECT, SBPS_NORMAL, size.cx);

}
// CGraphicView Ϣ

void CGraphicView::OnDot()
{
	// TODO: ڴ
	m_GraphType = DOT;
	SetSelectStatus("");
}

void CGraphicView::OnLine()
{
	// TODO: ڴ
	m_GraphType = LINE;
	SetSelectStatus("");
}

void CGraphicView::OnEllipse()
{
	// TODO: ڴ
	m_GraphType = ELLIPSE;
	SetSelectStatus("Բ");
}

void CGraphicView::OnRectangle()
{
	// TODO: ڴ
	m_GraphType = RECTANGLE;
	SetSelectStatus("");
}

void CGraphicView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	m_BeginPoint = point;
	m_MouseStatus = MOUSEDOWN;
	//HCURSOR hCursor = AfxGetApp()->LoadCursor(IDC_ARROW); //
	HCURSOR hCursor = LoadCursor(NULL, IDC_CROSS);
	SetCursor(hCursor);
	CView::OnLButtonDown(nFlags, point);
}

void CGraphicView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	m_MouseStatus = MOUSEUP;
	CView::OnLButtonUp(nFlags, point);
	ClearTrackLine();
	CClientDC dc(this);
	CPen penw(m_nLineType, m_iLineHeight, m_Color);
	dc.SelectObject(penw);
	CBrush *pBrush = CBrush::FromHandle((HBRUSH)GetStockObject(NULL_BRUSH));
	dc.SelectObject(pBrush);
	if(m_GraphType == ELLIPSE)
	{
		dc.Ellipse(m_BeginPoint.x, m_BeginPoint.y, point.x, point.y);
	}
	else if(m_GraphType == LINE)
	{
		dc.MoveTo(m_BeginPoint);
		dc.LineTo(point);
	}
	else if(m_GraphType == RECTANGLE)
	{
		dc.Rectangle(m_BeginPoint.x, m_BeginPoint.y, point.x, point.y);
	}
}

void CGraphicView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ڴϢ/Ĭֵ
	CString str;
	str.Format("x=%d, y=%d", point.x, point.y);
	GetParent()->GetDescendantWindow(AFX_IDW_STATUS_BAR)->SetWindowText(str);

	CView::OnMouseMove(nFlags, point);

	SetCursor(LoadCursor(NULL, IDC_CROSS));

	if(m_MouseStatus == MOUSEDOWN && 
		(m_GraphType == LINE || m_GraphType == ELLIPSE || m_GraphType == RECTANGLE))
	{
		ClearTrackLine();
		DrawTrackLine(point);
	}
	if(m_MouseStatus == MOUSEDOWN && m_GraphType == DOT)
	{
		CClientDC dc(this);
		dc.SetPixel(point, RGB(105, 105, 105));
	}
	m_LastPoint = point;
}

void CGraphicView::ClearTrackLine()
{
	CClientDC dc(this);
	CPen penw(m_nLineType, 1, RGB(255, 255, 255));
	dc.SelectObject(penw);
	dc.MoveTo(m_BeginPoint);
	dc.LineTo(m_LastPoint);
}

void CGraphicView::DrawTrackLine( CPoint &point )
{
	CClientDC dc(this);
	CPen pen(PS_DOT, 1, RGB(105, 105, 105));
	dc.SelectObject(pen);
	dc.MoveTo(m_BeginPoint);
	dc.LineTo(point);
}

void CGraphicView::OnSetting()
{
	// TODO: ڴ
	DialogSetting dlg;
	dlg.m_nLineHeight = m_iLineHeight;
	dlg.m_nLineType = m_nLineType;
	dlg.m_Color = m_Color;
	if(IDOK == dlg.DoModal())
	{
		CString str;
		m_nLineType = dlg.m_nLineType;
		m_iLineHeight = dlg.m_nLineHeight;
	}
}

void CGraphicView::OnColor()
{
	CColorDialog dlg;
	dlg.m_cc.Flags |= CC_FULLOPEN | CC_RGBINIT;
	dlg.m_cc.rgbResult = m_Color;
	if(IDOK == dlg.DoModal())
	{
		m_Color = dlg.m_cc.rgbResult;
	}
}

void CGraphicView::OnFont()
{
	// TODO: ڴ
	CFontDialog dlg;
	if(IDOK == dlg.DoModal())
	{
		if(m_Font.m_hObject)
			m_Font.DeleteObject();
		m_Font.CreateFontIndirect(dlg.m_cf.lpLogFont);
		m_strFontName = dlg.m_cf.lpLogFont->lfFaceName;
		Invalidate();
	}
}

BOOL CGraphicView::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ڴϢ/Ĭֵ

	CBitmap bitmap;
	bitmap.LoadBitmap(IDB_BITMAP1);
	BITMAP bmp;
	bitmap.GetBitmap(&bmp);
	CDC dcCompatible;
	dcCompatible.CreateCompatibleDC(pDC);
	dcCompatible.SelectObject(&bitmap);
	CRect rect;
	GetClientRect(&rect);
	//pDC->BitBlt(0, 0, rect.Width(), rect.Height(), &dcCompatible, 0, 0, SRCCOPY);
	pDC->StretchBlt(0, 0, rect.Width(), rect.Height(), 
		&dcCompatible, 0, 0, bmp.bmWidth, bmp.bmHeight, SRCCOPY);
	//return CView::OnEraseBkgnd(pDC);
	return true;

	//ػ, Ȳ,ػ洰.
	//ҲԷŵػOnDraw, OnDraw˸, ΪҪ, ٻ
}
